program sortierter_baum;
uses crt;
type
  namen=array[1..12] of string[10];
  zeiger=^daten;
  daten=record
          zahl:integer;
          links,rechts:zeiger;
          lord,rord,lanz,ranz:byte;
        end;
var
  anker:zeiger;
  order,anzahl,ordnung:byte;

function ausgeglichen(knoten:zeiger):boolean;
begin
  if knoten=nil then ausgeglichen:=true else
   begin
    if ((knoten^.lord-knoten^.rord>1)or(knoten^.lord-knoten^.rord<-1)
        or not(ausgeglichen(knoten^.links)and ausgeglichen(knoten^.rechts)))
      then ausgeglichen:=false;
   end;
end;

procedure schreibe(das:zeiger);
begin
  write(das^.lord);
  textcolor(darkgray);
  write(das^.lanz);
  textcolor(lightred);
  write(das^.zahl);
  textcolor(darkgray);
  write(das^.ranz);
  textcolor(lightgray);
  write(das^.rord,' ');
end;

procedure baum(element:zeiger;xpos,ypos:byte);
var
  correct:byte;
begin
  if ((element<>nil)and(ypos<8)) then
    begin
      gotoxy((xpos-3),ypos);
      schreibe(element);
      case ypos of
        1:correct:=17;
        2:correct:=9;
        3:correct:=5;
        4:correct:=3;
       else correct:=2;
      end;
      inc(ypos);
      baum(element^.links,(xpos-correct),ypos);
      baum(element^.rechts,(xpos+correct),ypos);
    end;
end;

procedure ausgabe(element:zeiger;order:byte);
begin
  if element<>nil then
    begin
      inc(anzahl);
      if order=1 then schreibe(element); {pre-order}
      ausgabe(element^.links,order);
      if order=2 then schreibe(element); {in-order}
      ausgabe(element^.rechts,order);
      if order=3 then schreibe(element); {post-order}
    end;
end;

procedure vor_ausgabe(order:byte;var alty:byte);
begin
  case order of
    1: write('pre-order: ');
    2: write('in-order: ');
    3: write('post-order: ');
  end;
  anzahl:=0;
  ausgabe(anker,order);
  writeln;
  alty:=wherey;
  window(1,17,80,25);
  textbackground(blue); clrscr;
  write(anzahl:4,' Zahlen');
  gotoxy(60,wherey);
  if ausgeglichen(anker) then write('Ausgeglichen')
                         else write('Nicht ausgeglichen');
  clreol;
  baum(anker,40,1);
  textbackground(black);
end;

procedure einfuegen(var stelle:zeiger;element:zeiger);
begin
  write('.');
  if stelle=nil then
    begin
      writeln('NIL ');
      stelle:=element;
      ordnung:=0;
    end
  else
    begin
      write(stelle^.zahl);
      if element^.zahl<stelle^.zahl then
        begin
          inc(stelle^.lanz);
          einfuegen(stelle^.links,element);
          inc(ordnung);
          if ordnung > stelle^.lord then stelle^.lord:=ordnung;
        end
      else
        begin
          inc(stelle^.ranz);
          einfuegen(stelle^.rechts,element);
          inc(ordnung);
          if ordnung > stelle^.rord then stelle^.rord:=ordnung;
        end;
    end;
end;

procedure anfuegen;
var neu:zeiger;
begin
  new(neu);
  neu^.links:=nil;
  neu^.rechts:=nil;
  neu^.lord:=0;
  neu^.rord:=0;
  neu^.lanz:=0;
  neu^.ranz:=0;
  write('Einfgen: Welche Zahl? ');
  readln(neu^.zahl);
  write('Zahl einfgen bei');
  einfuegen(anker,neu);
end;


procedure loeschen;
var
  zahl:byte;
  procedure loesche(var wo:zeiger);
  var merke:zeiger;
  begin
    write('.');
    if wo=nil then write('NIL ') else write(wo^.zahl);
    if wo <> nil then
      if wo^.zahl=zahl then
        begin
          writeln(' Gefunden!  Rechten Ast merken!!! Linken Ast ''zurckziehen''!');
          merke:=wo^.rechts;
          wo:=wo^.links;
          write('Rechten Ast einfgen');
          if merke <> nil then einfuegen(anker,merke);
          writeln;
        end
       else
         begin
           if wo^.zahl>zahl then loesche(wo^.links)
                            else loesche(wo^.rechts);
         end;
  end;
begin
  write('Lschen: Welche Zahl? ');
  readln(zahl);
  loesche(anker);
end;

procedure main;
var
  ch:char;
  alty:byte;
begin
  order:=1;
  alty:=2;
  repeat
    window(1,1,80,16);
    gotoxy(1,1);
    write('Anfgen(Eingabe), Lschen(Entf), Reihenfolge(1, 2, 3), Ende(Esc)? ');
    clreol;
    ch:=readkey;
    gotoxy(1,alty);
    case ch of
      char(13): anfuegen;
      'S': loeschen;
      '1': order:=1;
      '2': order:=2;
      '3': order:=3;
      else if ch <> char(0) then write('''',ch,''': Den Befehl gibt''s nicht! ');
    end;
    if ch<> char(0) then vor_ausgabe(order,alty);
  until ord(ch)=27;
end;

begin
  textbackground(black);
  clrscr;
  new(anker);
  anker:=nil;
  main;
end.